/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#include "messages.h"

void congratulations (void)
{
	acquire_screen();
	clear_to_color(screen, makecol(0,0,0));

	textout_centre_ex(screen, font, "vivaa!!! o//", SCREEN_W/2, SCREEN_H/2,
			   makecol(255, 255, 255), makecol(0, 0, 0));

	release_screen();
	rest(500);
}

/*----------------------------------------------------------------------------*/

void error_opening_stage (char *stage_to_open)
{
	acquire_screen();
	clear_to_color(screen, makecol(0,0,0));

	textout_ex (screen, font, "Error opening stage", 10, 10,
	            makecol(255, 255, 255), makecol(0, 0, 0));
	textprintf_ex (screen, font, 10, 20, makecol(255, 255, 255), -1,
				   "Failed to open stage '%s'", stage_to_open);

	release_screen();

	rest(2000);
	finish_game();
}

/*----------------------------------------------------------------------------*/

void error_allocating_memory (char *error_source)
{
	acquire_screen();
	clear_to_color(screen, makecol(0,0,0));

	textout_ex (screen, font, "Error allocating memory", 10, 10,
		    makecol(255, 255, 255), makecol(0, 0, 0));
	textprintf_ex (screen, font, 10, 20, makecol(255, 255, 255), -1,
		      "Failed to allocate memory from '%s'", error_source);

	release_screen();
	rest(2000);
	finish_game();
}

/*----------------------------------------------------------------------------*/

int welcome (void)
{
	int new_game = 0;
    key[KEY_UP] = 1;

    BITMAP *buffer = create_bitmap(SCREEN_W, SCREEN_H);
    BITMAP *start_bg = load_bitmap("image/start.bmp", NULL);

	do
	{
		if( key[KEY_UP] || key[KEY_DOWN] )
		{
            key[KEY_UP] = 0;
			acquire_screen();
            draw_sprite(buffer, start_bg, 0, 0);
        	//clear_to_color(buffer, makecol(0,0,0));

			//board
        	rect(buffer, 0,0,SCREEN_W-1,SCREEN_H-2, makecol(0,255,0));
	        rect(buffer, 1,1,SCREEN_W-2,SCREEN_H-2, makecol(0,255,0));
    	    rect(buffer, 2,2,SCREEN_W-3,SCREEN_H-3, makecol(0,255,0));
    	    rect(buffer, 3,3,SCREEN_W-4,SCREEN_H-4, makecol(0,255,0));
			//end board

        	textout_centre_ex(buffer, font, "!!! Shove-it !!!",
	                  SCREEN_W/2, 10, makecol(255, 0, 0), makecol(0, 0, 0));

        	textout_centre_ex(buffer, font, "New game", SCREEN_W/2, SCREEN_H/2-30,
	                  makecol(255, 0, 0), -1);

        	textout_centre_ex(buffer, font, "Continue", SCREEN_W/2, SCREEN_H/2-10,
					  makecol(255, 0, 0), -1);

            new_game=!new_game;

           	textout_ex(buffer, font, "*", SCREEN_W/2-46, SCREEN_H/2-30 +!new_game*21,
	 	        	  makecol(255, 0, 0), -1);

        	textout_ex(buffer, font, " ", SCREEN_W/2-46, SCREEN_H/2-30 +new_game*21,
        			  makecol(255, 0, 0), -1);

			draw_sprite(screen, buffer, 0, 0);
			release_screen();
		}

		else if(key[KEY_ESC])
			finish_game();

    clear_keybuf();
	readkey();
	} while ( !key[KEY_ENTER]);

	return (new_game);
}

/*----------------------------------------------------------------------------*/

void show_password(int level)
{

    acquire_screen();
	clear_to_color(screen, makecol(0,0,0));

    
   	textout_centre_ex(screen, font, "YOU HAVE GONE SO FAR!!! HERE IS YOUR PASSWORD!",
            SCREEN_W/2, SCREEN_H/2-15, makecol(155, 155, 0), makecol(0, 0, 0));
   	textout_centre_ex(screen, font, "press any key to continue",
            SCREEN_W/2, SCREEN_H/2+15, makecol(155, 155, 0), makecol(0, 0, 0));

    switch (level)
    {
        case 11 :
        	textout_centre_ex(screen, font, "marina!!",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 21 :
        	textout_centre_ex(screen, font, "malibu",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
        case 31 :
        	textout_centre_ex(screen, font, "sanpedro",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 41 :
        	textout_centre_ex(screen, font, "ventura?",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 51 :
        	textout_centre_ex(screen, font, "sasndiego",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 61 :
        	textout_centre_ex(screen, font, "pasadena",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 71 :
        	textout_centre_ex(screen, font, "!beverly",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 81 :
        	textout_centre_ex(screen, font, "melrose",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 91 :
        	textout_centre_ex(screen, font, "rodeo!?!",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 101 :
        	textout_centre_ex(screen, font, "westwood",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 111 :
        	textout_centre_ex(screen, font, "wilshire",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 121 :
        	textout_centre_ex(screen, font, "venice??",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 131 :
        	textout_centre_ex(screen, font, "figueroa",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 141 :
        	textout_centre_ex(screen, font, "sunset",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 151 :
        	textout_centre_ex(screen, font, "orange",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        case 161 :
        	textout_centre_ex(screen, font, "!ayasam!",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
        default :
        	textout_centre_ex(screen, font, "entrou",
	                  SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), makecol(0, 0, 0));
            break;
    }

    release_screen();
    readkey();
}
