/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#include "move_player.h"

//x and y parameters are changed because allegro works that way
void move_player (field *stage, int y, int x)
{
	int already_moved = 0;

	//moving without box
	if ( (stage->field[ stage->player.x + x ]
                      [ stage->player.y + y ] == FREE_SPACE) ||
		 (stage->field[ stage->player.x + x ]
	                  [ stage->player.y + y ] == RIGHT_PLACE) )
	{
		stage->player.x += x;
		stage->player.y += y;
		already_moved = 1;
	}

	//moving with box
	if ( (stage->field[ stage->player.x + x ]
					  [ stage->player.y + y ] == BOX) &&
							   (already_moved == 0) )//otherwise may move twice
	{
		//moving the box on free spaces or right places
		if ( stage->field[ stage->player.x + (2*x) ]
						 [ stage->player.y + (2*y) ] == FREE_SPACE)
		{
			stage->field[ stage->player.x + x ]
						[ stage->player.y + y ] = FREE_SPACE;

			stage->field[ stage->player.x + (2*x) ]
						[ stage->player.y + (2*y) ] = BOX;
			stage->player.x += x;
			stage->player.y += y;
		}

	}
}

/*-------------------------------------------------------------------------------------------------------------------*/

//x and y parameters are changed because allegro works that way
int allowed_move (field *stage, int y, int x)
{
	int already_moved = 0;
	int permission = 0;

	//moving without box
	if ( (stage->field[ stage->player.x + x ]
                      [ stage->player.y + y ] == FREE_SPACE) ||
		 (stage->field[ stage->player.x + x ]
	                  [ stage->player.y + y ] == RIGHT_PLACE) )
	{
		permission = 1;
		already_moved = 1;
	}

	//moving with box
	if ( (stage->field[ stage->player.x + x ]
					  [ stage->player.y + y ] == BOX) &&
							   (already_moved == 0) )//otherwise may move twice
		//moving the box on free spaces or right places
		if ( stage->field[ stage->player.x + (2*x) ]
						 [ stage->player.y + (2*y) ] == FREE_SPACE)

			permission = 1;

	return (permission);
}

/*-------------------------------------------------------------------------------------------------------------------*/

//x and y parameters are changed because allegro works that way
int which_animation (field *stage, int y, int x)
{
	//moving with box
	if ( (stage->field[ stage->player.x + x ]
					  [ stage->player.y + y ] == BOX) )
			return (1);

	return (0);
}
