/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#include "print_game.h"

void refresh_temp_bitmap(BITMAP *bmp, int direction, field *stage, int with_box)
{
    if (!bmp)
        exit (0);

    if (with_box == 0)
    {
        if (direction == UP)
        {
            if ( is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
                
            if (is_right_place(stage, stage->player.x+1,stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
        }
        if (direction == DOWN)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
                    
            if (is_right_place(stage, stage->player.x-1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
        if (direction == RIGHT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y-1) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
        if (direction == LEFT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y+1) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
        }
    }

    if (with_box == 1)
    {
        if (direction == UP)
        {
            if ( is_right_place(stage, stage->player.x-1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);

            if ( is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
                
            if (is_right_place(stage, stage->player.x+1,stage->player.y) )
                draw_sprite(bmp, right_place, 0, 2*GAP);
                else
                    draw_sprite(bmp, bkg, 0, 2*GAP);
        }
        if (direction == DOWN)
        {
            if (is_right_place(stage, stage->player.x-1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);

            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
                    
            if (is_right_place(stage, stage->player.x+1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 2*GAP);
                else
                    draw_sprite(bmp, bkg, 0, 2*GAP);
        }
        if (direction == RIGHT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y+1) )
                draw_sprite(bmp, right_place, 2*GAP, 0);
                else
                    draw_sprite(bmp, bkg, 2*GAP, 0);

            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y-1) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
        if (direction == LEFT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y+1) )
                draw_sprite(bmp, right_place, 2*GAP, 0);
                else
                    draw_sprite(bmp, bkg, 2*GAP, 0);

            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y-1) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
    }
}


void print_game (field *stage, int move, int with_box)
{

	int i;

    //creating temporary bitmap in order to refresh only changed area
    //in game (improve performance)
    BITMAP *temp;
    if (with_box == 1)
    {
	    if (move == RIGHT || move == LEFT)
            temp = create_bitmap(3*GAP,GAP);
        if (move == UP || move == DOWN)
            temp = create_bitmap(GAP,3*GAP);
    }
    else
    {
	    if (move == RIGHT || move == LEFT)
            temp = create_bitmap(2*GAP,GAP);
        if (move == UP || move == DOWN)
            temp = create_bitmap(GAP,2*GAP);
    }

    acquire_screen();

    //drawing animation without box
    if (with_box == 0)
    {
        if (move == UP)
	    {
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[1+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
        }
		if (move == DOWN)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
            step=!step;
            player[12]=player[7+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
        }
		if (move == RIGHT)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[4+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
        }
		if (move == LEFT)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ GAP-i, 10);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[10+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ GAP-i, 10);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
        }

        //displays box at right places (gray ones)
        for (i=0; i<stage->number_of_right_places; i++)
            if (stage->field[stage->right_places[i].x][stage->right_places[i].y]
                == BOX)
                draw_sprite(screen, box_at_place, stage->right_places[i].y*GAP, stage->right_places[i].x*GAP);
    }
    //drawing animation with box
    else
    {
		if (move == UP)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP-i);
                draw_sprite(temp, player[12], 10, 10+ 2*GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
            step=!step;
            player[12]=player[1+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP-i);
                draw_sprite(temp, player[12], 10, 10+ 2*GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
        }
		if (move == DOWN)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP+i);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
            step=!step;
            player[12]=player[7+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP+i);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
        }
		if (move == RIGHT)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP+i, 0);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[4+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP+i, 0);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
        }
		if (move == LEFT)
		{
            for (i=0; i<=GAP/2; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP-i, 0);
                draw_sprite(temp, player[12], 10+ 2*GAP-i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[10+step];
            for (i=GAP/2+1; i<=GAP; i+= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP-i, 0);
                draw_sprite(temp, player[12], 10+ 2*GAP-i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
        }

        //displays box at right places (gray ones)
        for (i=0; i<stage->number_of_right_places; i++)
            if (stage->field[stage->right_places[i].x][stage->right_places[i].y]
                == BOX)
                draw_sprite(screen, box_at_place, stage->right_places[i].y*GAP, stage->right_places[i].x*GAP);
	}

    if(!keypressed())
        player[12] = player[3*move];

    draw_sprite(screen, player[12], 10+ stage->player.y*GAP, 10+ stage->player.x*GAP);
    destroy_bitmap(temp);
    release_screen();
}

void refresh_temp_bitmap_for_come_back(BITMAP *bmp, int direction, field *stage, int with_box)
{
    if (!bmp)
        exit (0);

    if (with_box == 0)
    {
        if (direction == UP)
        {
            if ( is_right_place(stage, stage->player.x-1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
                
            if (is_right_place(stage, stage->player.x,stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
        }
        if (direction == DOWN)
        {
            if (is_right_place(stage, stage->player.x+1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
                    
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
        if (direction == RIGHT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y+1) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
        if (direction == LEFT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y-1) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
        }
    }

    if (with_box == 1)
    {
        if (direction == UP)
        {
            if ( is_right_place(stage, stage->player.x-2, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);

            if ( is_right_place(stage, stage->player.x-1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
                
            if (is_right_place(stage, stage->player.x,stage->player.y) )
                draw_sprite(bmp, right_place, 0, 2*GAP);
                else
                    draw_sprite(bmp, bkg, 0, 2*GAP);
        }
        if (direction == DOWN)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);

            if (is_right_place(stage, stage->player.x+1, stage->player.y) )
                draw_sprite(bmp, right_place, 0, GAP);
                else
                    draw_sprite(bmp, bkg, 0, GAP);
                    
            if (is_right_place(stage, stage->player.x+2, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 2*GAP);
                else
                    draw_sprite(bmp, bkg, 0, 2*GAP);
        }
        if (direction == RIGHT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y+2) )
                draw_sprite(bmp, right_place, 2*GAP, 0);
                else
                    draw_sprite(bmp, bkg, 2*GAP, 0);

            if (is_right_place(stage, stage->player.x, stage->player.y+1) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);
        }
        if (direction == LEFT)
        {
            if (is_right_place(stage, stage->player.x, stage->player.y-2) )
                draw_sprite(bmp, right_place, 0, 0);
                else
                    draw_sprite(bmp, bkg, 0, 0);

            if (is_right_place(stage, stage->player.x, stage->player.y-1) )
                draw_sprite(bmp, right_place, GAP, 0);
                else
                    draw_sprite(bmp, bkg, GAP, 0);
                
            if (is_right_place(stage, stage->player.x, stage->player.y) )
                draw_sprite(bmp, right_place, 2*GAP, 0);
                else
                    draw_sprite(bmp, bkg, 2*GAP, 0);
        }
    }
}


void reprint_game (field *stage, int move, int with_box)
{

	int i;

    //creating temporary bitmap in order to refresh only changed area
    //in game (improve performance)
    BITMAP *temp;
    if (with_box == 1)
    {
	    if (move == RIGHT || move == LEFT)
            temp = create_bitmap(3*GAP,GAP);
        if (move == UP || move == DOWN)
            temp = create_bitmap(GAP,3*GAP);
    }
    else
    {
	    if (move == RIGHT || move == LEFT)
            temp = create_bitmap(2*GAP,GAP);
        if (move == UP || move == DOWN)
            temp = create_bitmap(GAP,2*GAP);
    }

    acquire_screen();

    //drawing animation without box
    if (with_box == 0)
    {
        if (move == UP)
	    {
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
            step=!step;
            player[12]=player[1+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-1)*GAP);
            }
        }
		if (move == DOWN)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[7+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
        }
		if (move == RIGHT)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[4+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
        }
		if (move == LEFT)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ GAP-i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[10+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 0);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, player[12], 10+ GAP-i, 10);
                draw_sprite(screen, temp, (stage->player.y-1)*GAP, stage->player.x*GAP);
            }
        }

        //displays box at right places (gray ones)
        for (i=0; i<stage->number_of_right_places; i++)
            if (stage->field[stage->right_places[i].x][stage->right_places[i].y]
                == BOX)
                draw_sprite(screen, box_at_place, stage->right_places[i].y*GAP, stage->right_places[i].x*GAP);
    }
    //drawing animation with box
    else
    {
		if (move == UP)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP-i);
                draw_sprite(temp, player[12], 10, 10+ 2*GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-2)*GAP);
            }
            step=!step;
            player[12]=player[1+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP-i);
                draw_sprite(temp, player[12], 10, 10+ 2*GAP-i);
                draw_sprite(screen, temp, stage->player.y*GAP, (stage->player.x-2)*GAP);
            }
        }
		if (move == DOWN)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP+i);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[7+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, 0, GAP+i);
                draw_sprite(temp, player[12], 10, 10+ i);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
        }
		if (move == RIGHT)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP+i, 0);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[4+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP+i, 0);
                draw_sprite(temp, player[12], 10+ i, 10);
                draw_sprite(screen, temp, stage->player.y*GAP, stage->player.x*GAP);
            }
        }
		if (move == LEFT)
		{
            for (i=GAP; i>=GAP/2; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP-i, 0);
                draw_sprite(temp, player[12], 10+ 2*GAP-i, 10);
                draw_sprite(screen, temp, (stage->player.y-2)*GAP, stage->player.x*GAP);
            }
            step=!step;
            player[12]=player[10+step];
            for (i=GAP/2+1; i>=0; i-= PIXEL_JUMP_AT_ANI)
            {
                refresh_temp_bitmap_for_come_back(temp, move, stage, 1);
                rest(TIME_TO_REST_AT_ANI);
                draw_sprite(temp, box, GAP-i, 0);
                draw_sprite(temp, player[12], 10+ 2*GAP-i, 10);
                draw_sprite(screen, temp, (stage->player.y-2)*GAP, stage->player.x*GAP);
            }
        }

        //displays box at right places (gray ones)
        for (i=0; i<stage->number_of_right_places; i++)
            if (stage->field[stage->right_places[i].x][stage->right_places[i].y]
                == BOX)
                draw_sprite(screen, box_at_place, stage->right_places[i].y*GAP, stage->right_places[i].x*GAP);
	}

    if(!keypressed())
        player[12] = player[3*move];

    draw_sprite(screen, player[12], 10+ stage->player.y*GAP, 10+ stage->player.x*GAP);
    destroy_bitmap(temp);
    release_screen();
}
